﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestMMConverter
{
    class Program
    {
        static void Main(string[] args)
        {
            MMConverter conventer = new MMConverter();

            IStone stone = new Stone1();
            Water water = new Water();

            MM mm = conventer.ConvertFromStoneToMM(stone, water);
        }
    }

    public class MMConverter
    {
        public MM ConvertFromStoneToMM(IStone stone, Water water)
        {
            var gold = ConvertFromStoneToGold(stone, water);

            var diamond = ConvertFromGoldToDiamond(gold);

            return ConvertFromDiamondToMM(diamond);
        }

        Gold ConvertFromStoneToGold(IStone stone, Water water)
        {
            return new Gold();
        }

        IDiamond ConvertFromGoldToDiamond(Gold gold)
        {
            IDiamond diamond = DiamondFactory.CreateDiamond("Shanghai");

            Console.WriteLine(diamond.Quality);

            return diamond;
        }

        MM ConvertFromDiamondToMM(IDiamond diamond)
        {
            return new MM();
        }
    }

    public interface IStone
    {

    }

    public class Stone1 : IStone
    {

    }

    public class Stone2 : IStone
    {

    }

    public class Water
    {

    }

    public class Gold
    {

    }

    public class MM
    {

    }

    public interface IDiamond
    {
        string Quality { get; set; }
    }

    public class DiamondInShanghai : IDiamond
    {
        public string Quality { get; set; }

        public DiamondInShanghai()
        {
            this.Quality = "good";
        }
    }

    public class DiamondInHangzhou : IDiamond
    {
        public string Quality { get; set; }

        public DiamondInHangzhou()
        {
            this.Quality = "bad";
        }
    }

    public class DiamondFactory
    {
        public static IDiamond CreateDiamond(string address)
        {
            IDiamond diamond = null;

            switch (address.ToLower())
            {
                case "shanghai":
                    diamond = new DiamondInShanghai();
                    break;
                case "hangzhou":
                    diamond = new DiamondInHangzhou();
                    break;
            }

            return diamond;
        }
    }
}